<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/indexmap-1.9.1/src/map/core/raw.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>raw.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../../storage.js"></script><script defer src="../../../../source-script.js"></script><script defer src="../../../../source-files.js"></script><script defer src="../../../../main.js"></script><noscript><link rel="stylesheet" href="../../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../../indexmap/index.html"><div class="logo-container"><img class="rust-logo" src="../../../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../../indexmap/index.html"><div class="logo-container"><img class="rust-logo" src="../../../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../../indexmap/index.html"><img class="rust-logo" src="../../../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
</pre><pre class="rust"><code><span class="attribute">#![<span class="ident">allow</span>(<span class="ident">unsafe_code</span>)]</span>
<span class="doccomment">//! This module encapsulates the `unsafe` access to `hashbrown::raw::RawTable`,</span>
<span class="doccomment">//! mostly in dealing with its bucket &quot;pointers&quot;.</span>

<span class="kw">use</span> <span class="kw">super</span>::{<span class="ident">equivalent</span>, <span class="ident">Bucket</span>, <span class="ident">Entry</span>, <span class="ident">HashValue</span>, <span class="ident">IndexMapCore</span>, <span class="ident">VacantEntry</span>};
<span class="kw">use</span> <span class="ident">core::fmt</span>;
<span class="kw">use</span> <span class="ident">core::mem::replace</span>;
<span class="kw">use</span> <span class="ident">hashbrown::raw::RawTable</span>;

<span class="kw">type</span> <span class="ident">RawBucket</span> <span class="op">=</span> <span class="ident">hashbrown::raw::Bucket</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>;

<span class="doccomment">/// Inserts many entries into a raw table without reallocating.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ***Panics*** if there is not sufficient capacity already.</span>
<span class="kw">pub</span>(<span class="kw">super</span>) <span class="kw">fn</span> <span class="ident">insert_bulk_no_grow</span><span class="op">&lt;</span><span class="ident">K</span>, <span class="ident">V</span><span class="op">&gt;</span>(<span class="ident">indices</span>: <span class="kw-2">&amp;mut</span> <span class="ident">RawTable</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>, <span class="ident">entries</span>: <span class="kw-2">&amp;</span>[<span class="ident">Bucket</span><span class="op">&lt;</span><span class="ident">K</span>, <span class="ident">V</span><span class="op">&gt;</span>]) {
    <span class="macro">assert!</span>(<span class="ident">indices</span>.<span class="ident">capacity</span>() <span class="op">-</span> <span class="ident">indices</span>.<span class="ident">len</span>() <span class="op">&gt;</span><span class="op">=</span> <span class="ident">entries</span>.<span class="ident">len</span>());
    <span class="kw">for</span> <span class="ident">entry</span> <span class="kw">in</span> <span class="ident">entries</span> {
        <span class="comment">// SAFETY: we asserted that sufficient capacity exists for all entries.</span>
        <span class="kw">unsafe</span> {
            <span class="ident">indices</span>.<span class="ident">insert_no_grow</span>(<span class="ident">entry</span>.<span class="ident">hash</span>.<span class="ident">get</span>(), <span class="ident">indices</span>.<span class="ident">len</span>());
        }
    }
}

<span class="kw">pub</span>(<span class="kw">super</span>) <span class="kw">struct</span> <span class="ident">DebugIndices</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>(<span class="kw">pub</span> <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">RawTable</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>);
<span class="kw">impl</span> <span class="ident">fmt::Debug</span> <span class="kw">for</span> <span class="ident">DebugIndices</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;mut</span> <span class="ident">fmt::Formatter</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>) -&gt; <span class="ident">fmt::Result</span> {
        <span class="comment">// SAFETY: we&#39;re not letting any of the buckets escape this function</span>
        <span class="kw">let</span> <span class="ident">indices</span> <span class="op">=</span> <span class="kw">unsafe</span> { <span class="self">self</span>.<span class="number">0</span>.<span class="ident">iter</span>().<span class="ident">map</span>(<span class="op">|</span><span class="ident">raw_bucket</span><span class="op">|</span> <span class="ident">raw_bucket</span>.<span class="ident">read</span>()) };
        <span class="ident">f</span>.<span class="ident">debug_list</span>().<span class="ident">entries</span>(<span class="ident">indices</span>).<span class="ident">finish</span>()
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">K</span>, <span class="ident">V</span><span class="op">&gt;</span> <span class="ident">IndexMapCore</span><span class="op">&lt;</span><span class="ident">K</span>, <span class="ident">V</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Sweep the whole table to erase indices start..end</span>
    <span class="kw">pub</span>(<span class="kw">super</span>) <span class="kw">fn</span> <span class="ident">erase_indices_sweep</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">start</span>: <span class="ident">usize</span>, <span class="ident">end</span>: <span class="ident">usize</span>) {
        <span class="comment">// SAFETY: we&#39;re not letting any of the buckets escape this function</span>
        <span class="kw">unsafe</span> {
            <span class="kw">let</span> <span class="ident">offset</span> <span class="op">=</span> <span class="ident">end</span> <span class="op">-</span> <span class="ident">start</span>;
            <span class="kw">for</span> <span class="ident">bucket</span> <span class="kw">in</span> <span class="self">self</span>.<span class="ident">indices</span>.<span class="ident">iter</span>() {
                <span class="kw">let</span> <span class="ident">i</span> <span class="op">=</span> <span class="ident">bucket</span>.<span class="ident">read</span>();
                <span class="kw">if</span> <span class="ident">i</span> <span class="op">&gt;</span><span class="op">=</span> <span class="ident">end</span> {
                    <span class="ident">bucket</span>.<span class="ident">write</span>(<span class="ident">i</span> <span class="op">-</span> <span class="ident">offset</span>);
                } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">i</span> <span class="op">&gt;</span><span class="op">=</span> <span class="ident">start</span> {
                    <span class="self">self</span>.<span class="ident">indices</span>.<span class="ident">erase</span>(<span class="ident">bucket</span>);
                }
            }
        }
    }

    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">entry</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">hash</span>: <span class="ident">HashValue</span>, <span class="ident">key</span>: <span class="ident">K</span>) -&gt; <span class="ident">Entry</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span>, <span class="ident">K</span>, <span class="ident">V</span><span class="op">&gt;</span>
    <span class="kw">where</span>
        <span class="ident">K</span>: <span class="ident">Eq</span>,
    {
        <span class="kw">let</span> <span class="ident">eq</span> <span class="op">=</span> <span class="ident">equivalent</span>(<span class="kw-2">&amp;</span><span class="ident">key</span>, <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">entries</span>);
        <span class="kw">match</span> <span class="self">self</span>.<span class="ident">indices</span>.<span class="ident">find</span>(<span class="ident">hash</span>.<span class="ident">get</span>(), <span class="ident">eq</span>) {
            <span class="comment">// SAFETY: The entry is created with a live raw bucket, at the same time</span>
            <span class="comment">// we have a &amp;mut reference to the map, so it can not be modified further.</span>
            <span class="prelude-val">Some</span>(<span class="ident">raw_bucket</span>) =&gt; <span class="ident">Entry::Occupied</span>(<span class="ident">OccupiedEntry</span> {
                <span class="ident">map</span>: <span class="self">self</span>,
                <span class="ident">raw_bucket</span>,
                <span class="ident">key</span>,
            }),
            <span class="prelude-val">None</span> =&gt; <span class="ident">Entry::Vacant</span>(<span class="ident">VacantEntry</span> {
                <span class="ident">map</span>: <span class="self">self</span>,
                <span class="ident">hash</span>,
                <span class="ident">key</span>,
            }),
        }
    }

    <span class="kw">pub</span>(<span class="kw">super</span>) <span class="kw">fn</span> <span class="ident">indices_mut</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) -&gt; <span class="kw">impl</span> <span class="ident">Iterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> <span class="kw-2">&amp;mut</span> <span class="ident">usize</span><span class="op">&gt;</span> {
        <span class="comment">// SAFETY: we&#39;re not letting any of the buckets escape this function,</span>
        <span class="comment">// only the item references that are appropriately bound to `&amp;mut self`.</span>
        <span class="kw">unsafe</span> { <span class="self">self</span>.<span class="ident">indices</span>.<span class="ident">iter</span>().<span class="ident">map</span>(<span class="op">|</span><span class="ident">bucket</span><span class="op">|</span> <span class="ident">bucket</span>.<span class="ident">as_mut</span>()) }
    }

    <span class="doccomment">/// Return the raw bucket for the given index</span>
    <span class="kw">fn</span> <span class="ident">find_index</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">index</span>: <span class="ident">usize</span>) -&gt; <span class="ident">RawBucket</span> {
        <span class="comment">// We&#39;ll get a &quot;nice&quot; bounds-check from indexing `self.entries`,</span>
        <span class="comment">// and then we expect to find it in the table as well.</span>
        <span class="kw">let</span> <span class="ident">hash</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">entries</span>[<span class="ident">index</span>].<span class="ident">hash</span>.<span class="ident">get</span>();
        <span class="self">self</span>.<span class="ident">indices</span>
            .<span class="ident">find</span>(<span class="ident">hash</span>, <span class="kw">move</span> <span class="op">|</span><span class="kw-2">&amp;</span><span class="ident">i</span><span class="op">|</span> <span class="ident">i</span> <span class="op">==</span> <span class="ident">index</span>)
            .<span class="ident">expect</span>(<span class="string">&quot;index not found&quot;</span>)
    }

    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">swap_indices</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">a</span>: <span class="ident">usize</span>, <span class="ident">b</span>: <span class="ident">usize</span>) {
        <span class="comment">// SAFETY: Can&#39;t take two `get_mut` references from one table, so we</span>
        <span class="comment">// must use raw buckets to do the swap. This is still safe because we</span>
        <span class="comment">// are locally sure they won&#39;t dangle, and we write them individually.</span>
        <span class="kw">unsafe</span> {
            <span class="kw">let</span> <span class="ident">raw_bucket_a</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">find_index</span>(<span class="ident">a</span>);
            <span class="kw">let</span> <span class="ident">raw_bucket_b</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">find_index</span>(<span class="ident">b</span>);
            <span class="ident">raw_bucket_a</span>.<span class="ident">write</span>(<span class="ident">b</span>);
            <span class="ident">raw_bucket_b</span>.<span class="ident">write</span>(<span class="ident">a</span>);
        }
        <span class="self">self</span>.<span class="ident">entries</span>.<span class="ident">swap</span>(<span class="ident">a</span>, <span class="ident">b</span>);
    }
}

<span class="doccomment">/// A view into an occupied entry in a `IndexMap`.</span>
<span class="doccomment">/// It is part of the [`Entry`] enum.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [`Entry`]: enum.Entry.html</span>
<span class="comment">// SAFETY: The lifetime of the map reference also constrains the raw bucket,</span>
<span class="comment">// which is essentially a raw pointer into the map indices.</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">OccupiedEntry</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="ident">K</span>, <span class="ident">V</span><span class="op">&gt;</span> {
    <span class="ident">map</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="kw-2">mut</span> <span class="ident">IndexMapCore</span><span class="op">&lt;</span><span class="ident">K</span>, <span class="ident">V</span><span class="op">&gt;</span>,
    <span class="ident">raw_bucket</span>: <span class="ident">RawBucket</span>,
    <span class="ident">key</span>: <span class="ident">K</span>,
}

<span class="comment">// `hashbrown::raw::Bucket` is only `Send`, not `Sync`.</span>
<span class="comment">// SAFETY: `&amp;self` only accesses the bucket to read it.</span>
<span class="kw">unsafe</span> <span class="kw">impl</span><span class="op">&lt;</span><span class="ident">K</span>: <span class="ident">Sync</span>, <span class="ident">V</span>: <span class="ident">Sync</span><span class="op">&gt;</span> <span class="ident">Sync</span> <span class="kw">for</span> <span class="ident">OccupiedEntry</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span>, <span class="ident">K</span>, <span class="ident">V</span><span class="op">&gt;</span> {}

<span class="comment">// The parent module also adds methods that don&#39;t threaten the unsafe encapsulation.</span>
<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="ident">K</span>, <span class="ident">V</span><span class="op">&gt;</span> <span class="ident">OccupiedEntry</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="ident">K</span>, <span class="ident">V</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Gets a reference to the entry&#39;s key in the map.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Note that this is not the key that was used to find the entry. There may be an observable</span>
    <span class="doccomment">/// difference if the key type has any distinguishing features outside of `Hash` and `Eq`, like</span>
    <span class="doccomment">/// extra fields or the memory address of an allocation.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">key</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="ident">K</span> {
        <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">map</span>.<span class="ident">entries</span>[<span class="self">self</span>.<span class="ident">index</span>()].<span class="ident">key</span>
    }

    <span class="doccomment">/// Gets a reference to the entry&#39;s value in the map.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">get</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="ident">V</span> {
        <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">map</span>.<span class="ident">entries</span>[<span class="self">self</span>.<span class="ident">index</span>()].<span class="ident">value</span>
    }

    <span class="doccomment">/// Gets a mutable reference to the entry&#39;s value in the map.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// If you need a reference which may outlive the destruction of the</span>
    <span class="doccomment">/// `Entry` value, see `into_mut`.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">get_mut</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) -&gt; <span class="kw-2">&amp;mut</span> <span class="ident">V</span> {
        <span class="kw">let</span> <span class="ident">index</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">index</span>();
        <span class="kw-2">&amp;mut</span> <span class="self">self</span>.<span class="ident">map</span>.<span class="ident">entries</span>[<span class="ident">index</span>].<span class="ident">value</span>
    }

    <span class="doccomment">/// Put the new key in the occupied entry&#39;s key slot</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">replace_key</span>(<span class="self">self</span>) -&gt; <span class="ident">K</span> {
        <span class="kw">let</span> <span class="ident">index</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">index</span>();
        <span class="kw">let</span> <span class="ident">old_key</span> <span class="op">=</span> <span class="kw-2">&amp;mut</span> <span class="self">self</span>.<span class="ident">map</span>.<span class="ident">entries</span>[<span class="ident">index</span>].<span class="ident">key</span>;
        <span class="ident">replace</span>(<span class="ident">old_key</span>, <span class="self">self</span>.<span class="ident">key</span>)
    }

    <span class="doccomment">/// Return the index of the key-value pair</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">index</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">usize</span> {
        <span class="comment">// SAFETY: we have &amp;mut map keep keeping the bucket stable</span>
        <span class="kw">unsafe</span> { <span class="self">self</span>.<span class="ident">raw_bucket</span>.<span class="ident">read</span>() }
    }

    <span class="doccomment">/// Converts into a mutable reference to the entry&#39;s value in the map,</span>
    <span class="doccomment">/// with a lifetime bound to the map itself.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">into_mut</span>(<span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="kw-2">mut</span> <span class="ident">V</span> {
        <span class="kw">let</span> <span class="ident">index</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">index</span>();
        <span class="kw-2">&amp;mut</span> <span class="self">self</span>.<span class="ident">map</span>.<span class="ident">entries</span>[<span class="ident">index</span>].<span class="ident">value</span>
    }

    <span class="doccomment">/// Remove and return the key, value pair stored in the map for this entry</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Like `Vec::swap_remove`, the pair is removed by swapping it with the</span>
    <span class="doccomment">/// last element of the map and popping it off. **This perturbs</span>
    <span class="doccomment">/// the position of what used to be the last element!**</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Computes in **O(1)** time (average).</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">swap_remove_entry</span>(<span class="self">self</span>) -&gt; (<span class="ident">K</span>, <span class="ident">V</span>) {
        <span class="comment">// SAFETY: This is safe because it can only happen once (self is consumed)</span>
        <span class="comment">// and map.indices have not been modified since entry construction</span>
        <span class="kw">let</span> <span class="ident">index</span> <span class="op">=</span> <span class="kw">unsafe</span> { <span class="self">self</span>.<span class="ident">map</span>.<span class="ident">indices</span>.<span class="ident">remove</span>(<span class="self">self</span>.<span class="ident">raw_bucket</span>) };
        <span class="self">self</span>.<span class="ident">map</span>.<span class="ident">swap_remove_finish</span>(<span class="ident">index</span>)
    }

    <span class="doccomment">/// Remove and return the key, value pair stored in the map for this entry</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Like `Vec::remove`, the pair is removed by shifting all of the</span>
    <span class="doccomment">/// elements that follow it, preserving their relative order.</span>
    <span class="doccomment">/// **This perturbs the index of all of those elements!**</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Computes in **O(n)** time (average).</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">shift_remove_entry</span>(<span class="self">self</span>) -&gt; (<span class="ident">K</span>, <span class="ident">V</span>) {
        <span class="comment">// SAFETY: This is safe because it can only happen once (self is consumed)</span>
        <span class="comment">// and map.indices have not been modified since entry construction</span>
        <span class="kw">let</span> <span class="ident">index</span> <span class="op">=</span> <span class="kw">unsafe</span> { <span class="self">self</span>.<span class="ident">map</span>.<span class="ident">indices</span>.<span class="ident">remove</span>(<span class="self">self</span>.<span class="ident">raw_bucket</span>) };
        <span class="self">self</span>.<span class="ident">map</span>.<span class="ident">shift_remove_finish</span>(<span class="ident">index</span>)
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../../" data-current-crate="indexmap" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>